
#include "main.h"

// 
GTimer_ms TimerLostSignal;
GTimer_ms TimerServo;
//  
RF24 radio(10, 9);
//  
Servo ServoBunker_1;
Servo ServoBunker_2;
Servo ServoTurn;

//  

//  
uint8_t AngleBunker_1 = 0,  AngleBunker_1_Last = 0;
uint8_t AngleBunker_2 = 0,  AngleBunker_2_Last = 0;
uint8_t AngleTurn     = 90, AngleTurnLast      = 0;
uint8_t SpeedMain     = 0,  SpeedMainLast      = 0;
boolean Direction, DirectionLast, LostSignal;

void setup()
{
  Serial.begin(115200);
  //     
  ServoBunker_1.attach(SERVO_BUNKER_1);                                         //  1 
  ServoBunker_2.attach(SERVO_BUNKER_2);                                         //  2 
  ServoTurn.attach(SERVO_TURN);                                                 //  
  ServoBunker_1.write(AngleBunker_1);                                           //   1 
  ServoBunker_2.write(AngleBunker_2);                                           //   2 
  ServoTurn.write(AngleTurn);                                                   //   
  //  
  Direction           = false;
  DirectionLast       = Direction;
  LostSignal          = false;
  //    
  pinMode(PIN_RUN_FIRES, OUTPUT);                                               //   
  pinMode(PIN_SEARCH_LIGHT, OUTPUT);                                            //  
  pinMode(SPEED_KEY_1, OUTPUT);                                                 //   
  pinMode(SPEED_KEY_2, OUTPUT);       
  //  
  digitalWrite(PIN_RUN_FIRES, LOW);
  digitalWrite(PIN_SEARCH_LIGHT, LOW);
  analogWrite(SPEED_ENABLE, 0);
  digitalWrite(SPEED_KEY_1, HIGH);
  digitalWrite(SPEED_KEY_2, LOW);       
  //  
  TimerLostSignal.setInterval(300);
  TimerServo.setInterval(3);
  //  
  radio.begin();
  radio.setChannel(200);
  radio.setDataRate(RF24_2MBPS);
  radio.setPALevel(RF24_PA_MIN);
  radio.openReadingPipe (1, 0xAABBCCDD11LL);
  radio.setAutoAck(true);
  radio.startListening(); 

}

void loop() 
{
  // -----------------------------------------------------------------
  //    
  // -----------------------------------------------------------------
  if (radio.available())
  {
    //       
    TimerLostSignal.reset();
    //   
    radio.read( &ReceiveBuff, sizeof(ReceiveBuff) );
    //     ----------------------------
    if(ReceiveBuff.Turn >= 0)
      AngleTurn = map(ReceiveBuff.Turn, 0, 530, 90, 180);
    else
      AngleTurn = map(-ReceiveBuff.Turn, 0, 530, 90, 0);
    //   1  -------------------------------
    if(ReceiveBuff.Bunker_1)
      AngleBunker_1 = 180;
    else
      AngleBunker_1 = 0;
    //   2  -------------------------------
    if(ReceiveBuff.Bunker_2)
      AngleBunker_2 = 180;
    else
      AngleBunker_2 = 0;
    //    ---------------------------------
    if(ReceiveBuff.Speed >= 0)
    {
      SpeedMain = map(ReceiveBuff.Speed, 0, 530, 0, 255);
      Direction = true;
    }
    else
    {
      SpeedMain = map(-ReceiveBuff.Speed, 0, 530, 0, 255);
      Direction = false;
    }
    // /   -------------------------------
    digitalWrite(PIN_RUN_FIRES, ReceiveBuff.RunFires);
    // /  ----------------------------------
    digitalWrite(PIN_SEARCH_LIGHT, ReceiveBuff.SearchLight);
  }
  
  // -----------------------------------------------------------------
  //     
  // -----------------------------------------------------------------
  if(TimerServo.isReady())
  {
    //  
    if(AngleTurnLast != AngleTurn)
    {
      if(AngleTurnLast < AngleTurn) AngleTurnLast++;
      if(AngleTurnLast > AngleTurn) AngleTurnLast--;
      ServoTurn.write(AngleTurnLast);
    }
    // / 1 
    if(AngleBunker_1_Last != AngleBunker_1)
    {
      if(AngleBunker_1_Last < AngleBunker_1) AngleBunker_1_Last++;
      if(AngleBunker_1_Last > AngleBunker_1) AngleBunker_1_Last--;
      ServoBunker_1.write(AngleBunker_1_Last);
    }
    // /  
    if(AngleBunker_2_Last != AngleBunker_2)
    {
      if(AngleBunker_2_Last < AngleBunker_2) AngleBunker_2_Last++;
      if(AngleBunker_2_Last > AngleBunker_2) AngleBunker_2_Last--;
      ServoBunker_2.write(AngleBunker_2_Last);
    }
    //  
    if(SpeedMainLast != SpeedMain)
    {
      if(Direction == DirectionLast)
      {
        if(SpeedMainLast < SpeedMain) SpeedMainLast++;
        if(SpeedMainLast > SpeedMain) SpeedMainLast--;
      }
      else
      {
        if(SpeedMainLast > 0)
          SpeedMainLast--; 
        else
        {
          DirectionLast = Direction;
          if(DirectionLast)
          {
            digitalWrite(SPEED_KEY_1, LOW);
            digitalWrite(SPEED_KEY_2, HIGH);       
          }
          else
          {
            digitalWrite(SPEED_KEY_1, HIGH);
            digitalWrite(SPEED_KEY_2, LOW);
          }
        }
      }
      analogWrite(SPEED_ENABLE, SpeedMainLast);
    }
  }

  if(TimerLostSignal.isReady())
  {
    SpeedMain = 0;
  }
}

//      Serial.println("Pipe 1");
//      Serial.print("      : ");
//      Serial.println(ReceiveBuff.Turn);
//      Serial.println(AngleTurn);
//      Serial.print("          : ");
//      Serial.println(ReceiveBuff.Speed);
//      Serial.print(" 1     : ");
//      Serial.println(ReceiveBuff.Bunker_1);
//      Serial.print(" 2     : ");
//      Serial.println(ReceiveBuff.Bunker_2);
//      Serial.print("  : ");
//      Serial.println(ReceiveBuff.RunFires);
//      Serial.print("    : ");
//      Serial.println(ReceiveBuff.SearchLight);
//      Serial.print("    : ");
//      Serial.println(ReceiveBuff.Joystick);
//      Serial.println(""); 
