
#include "main.h"

//  
GButton Key_Bunker_1(BUNKER_1);
GButton Key_Bunker_2(BUNKER_2);
GButton Key_RunFires(RUN_FIRES);
GButton Key_SearchLight(SEARCH_LIGHT);
GButton Key_SwapJoy(JOY_SWAP);
//    
GTimer_ms TimerSend;
//  
RF24 radio(10, 9);

void setup()
{
  Serial.begin(115200);
  //   
  pinMode(JOY_1_X, INPUT);
  pinMode(JOY_1_Y, INPUT);
  pinMode(JOY_2_X, INPUT);
  pinMode(JOY_2_Y, INPUT);
  //         
  CalibrTurn_1  = analogRead(JOY_1_X);
  CalibrSpeed_1 = analogRead(JOY_1_Y);
  CalibrTurn_2  = analogRead(JOY_2_X);
  CalibrSpeed_2 = analogRead(JOY_2_Y);
  //   
  Key_Bunker_1.setTickMode(AUTO);
  Key_Bunker_2.setTickMode(AUTO);
  Key_RunFires.setTickMode(AUTO);
  Key_SearchLight.setTickMode(AUTO);
  Key_SwapJoy.setTickMode(AUTO);
  //   
  pinMode(LED_CONNECT, OUTPUT);
  digitalWrite(LED_CONNECT, LOW);
  //  
  TimerSend.setInterval(50);
  //    EEPROM
  EEPROM.get(0, SendBuff);
  //  
  radio.begin();
  radio.setChannel(200);
  radio.setDataRate (RF24_2MBPS);
  radio.setPALevel (RF24_PA_MIN);
  radio.openWritingPipe(0xAABBCCDD11LL);
  radio.setAutoAck(true);
  //  
  radio.powerUp();
}

void loop() 
{
  if(Key_Bunker_1.isClick())                                                    //    " 1"
  {
    if(SendBuff.Bunker_1)
      SendBuff.Bunker_1 = false;
    else
      SendBuff.Bunker_1 = true;
  }
  if(Key_Bunker_2.isClick())                                                    //    " 2"
  {
    if(SendBuff.Bunker_2)
      SendBuff.Bunker_2 = false;
    else
      SendBuff.Bunker_2 = true;
  }
  if(Key_RunFires.isClick())                                                    //    " "
  {
    if(SendBuff.RunFires)
      SendBuff.RunFires = false;
    else
      SendBuff.RunFires = true;
  }
  if(Key_SearchLight.isClick())                                                 //    ""
  {
    if(SendBuff.SearchLight)
      SendBuff.SearchLight = false;
    else
      SendBuff.SearchLight = true;
  }
  if(Key_SwapJoy.isClick())                                                     //    " "
  {
    if(SendBuff.Joystick)
      SendBuff.Joystick = false;
    else
      SendBuff.Joystick = true;
    EEPROM.put(0, SendBuff);
  }

  if(TimerSend.isReady())
  {
    //     
    if(SendBuff.Joystick)                                                       //   
    {
      SendBuff.Turn  = analogRead(JOY_1_X) - CalibrTurn_1;                      //  ,  
      SendBuff.Speed = analogRead(JOY_2_Y) - CalibrSpeed_2;
    }
    else
    {
      SendBuff.Turn  = analogRead(JOY_2_X) - CalibrTurn_2;                      //  ,  
      SendBuff.Speed = analogRead(JOY_1_Y) - CalibrSpeed_1;
    }

    if (radio.write(&SendBuff, sizeof(SendBuff)))
      digitalWrite(LED_CONNECT, HIGH);
    else
      digitalWrite(LED_CONNECT, LOW);
  }
}

/*  Serial.print("      : ");
  Serial.println(SendBuff.Turn);
  Serial.print("          : ");
  Serial.println(SendBuff.Speed);
  Serial.print(" 1     : ");
  Serial.println(SendBuff.Bunker_1);
  Serial.print(" 2     : ");
  Serial.println(SendBuff.Bunker_2);
  Serial.print("  : ");
  Serial.println(SendBuff.RunFires);
  Serial.print("    : ");
  Serial.println(SendBuff.SearchLight);
  Serial.print("    : ");
  Serial.println(SendBuff.Joystick);
  Serial.println(""); */
